<template>
  <ProDialog :title="title" v-model="visible" destroy-on-close draggable width="800px">
    <FourStreamsMaterialFileTableV2 v-model:list="form.list" v-bind="props" />
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="handleConfirm">确 定</el-button>
      </span>
    </template>
  </ProDialog>
</template>

<script setup lang="ts" generic="T">
import { ProDialog } from '@bole-core/components';
import FourStreamsMaterialFileTableV2 from './FourStreamsMaterialFileTableV2.vue';
import { FourStreamsMaterialFileTableProps, BaseMaterialFileTableItem } from './types';

defineOptions({
  name: 'FourStreamsMaterialFileDialogV2',
});

type Props = FourStreamsMaterialFileTableProps & {
  title?: string;
  BusinessTypeEnumText: { [key: number]: string };
};

const props = withDefaults(defineProps<Props>(), {
  showUploadBtn: true,
  showCheckBtn: true,
  showDownloadBtn: true,
  showDeleteBtn: true,
  title: '材料详情',
});

const visible = defineModel({ type: Boolean });

type Form = {
  list: BaseMaterialFileTableItem<T>[];
};

const form = defineModel<Form>('form');

const emit = defineEmits<{
  (e: 'onConfirm'): void;
  (e: 'onCancel'): void;
}>();

function handleConfirm() {
  emit('onConfirm');
}
</script>
